jQuery.plugin(
  "de_epages.shipping.inc.newdeliverydialog",
  [
    'ep.ajax',
    'ep.ui.dialog',
    'jQuery.ui.draggable',
    'ep.alert'
  ],
  function ($) {

    var newdeliverydialog = $.scope("de_epages.shipping.inc").newdeliverydialog = {

      ShopObjectId: null,
      NewDeliveryMethodDialog: null,
      CurrentShippingFulfillmentItem: null,
      CurrentShippingTypeList: null,
      CurrentShippingTypeItem: null,

      open: function( objectId ){
        this.ShopObjectId = objectId ;
        ep('.Dialog').busy('show');
        ep.ajax({
          url: "?ViewAction=MBO-AddNewDeliveryMethodDialog&ObjectID=" + this.ShopObjectId
        })
        .done( function( data ){
          newdeliverydialog.show( data );
        })
        .fail( function(){
          newdeliverydialog.ajaxError();
        })
        .always( function(){
          ep('.Dialog').busy('hide');
        });
      },

      show: function ( data ){
        if ( this.NewDeliveryMethodDialog == null ){
          this.NewDeliveryMethodDialog =
              ep( '#'+'AddShippingDialog' )
                .html( data )
                .uiDialog({
                  title : ep('#AddShippingDialogLabels > #DialogTitle').html(),
                  modal: true,
                  autoOpen: false,
                  draggable: true,
                  resizable: false,
                  width : 700,
                  maxHeight: 600,
                  buttons: [
                    {
                      text: ep('#AddShippingDialogLabels > #OkButton').html(),
                      click: function(){
                        newdeliverydialog.submit();
                      }
                    },
                    {
                      text: ep('#AddShippingDialogLabels > #CloseButton').html(),
                      click: function(){
                        newdeliverydialog.close();
                      }
                    }
                  ]
                });
        } else {
          this.NewDeliveryMethodDialog.html( data );
        }
        this.init();
        this.NewDeliveryMethodDialog.uiDialog('open');
      },

      submit: function () {
        this.lock( true );
        this.submitShippingFulfillment();
        this.submitShippingType();
        var self = this;

        ep.ajax({
          url: "?ViewAction=MBO-AddNewDeliveryMethodDialog&ObjectID=" + this.ShopObjectId,
          type: "POST",
          data: ep( '#'+'NewDeliveryMethodForm' ).serialize()
        })
        .done( function( data ){
          newdeliverydialog.reload( data );
        })
        .fail( function(){
          newdeliverydialog.ajaxError();
        })
        .always( function(){
          newdeliverydialog.lock( false );
        });
      },

      reload: function ( data ){
        var newShippingMethodId = null;
        var gotoView = null;
        var regexp = new RegExp('\\bid="NewShippingMethodID" value="(\\d+)"') ;
        var result = regexp.exec( data ) ;
        if ( result != null ) {
            newShippingMethodId = result[1];
            regexp = new RegExp('\\bid="GotoView" value="(.+)"') ;
            result = regexp.exec( data ) ;
            gotoView = result[1] ;
        }
        if ( newShippingMethodId != null ){
          this.NewDeliveryMethodDialog.uiDialog('close');
          ep('.Dialog').busy('show');
          document.location = '?ViewAction=' + gotoView + '&ObjectID=' + newShippingMethodId;
        }
        else {
          this.NewDeliveryMethodDialog.html( data );
          this.init();
          this.NewDeliveryMethodDialog.uiDialog('open');
        }
      },

      init: function(){
        this.onLoadShippingType();
        this.onLoadShippingFulfillment();
      },

      close: function (){
        this.NewDeliveryMethodDialog.uiDialog('close');
      },

      lock: function ( lock ){
        if ( this.NewDeliveryMethodDialog != null ){
          this.NewDeliveryMethodDialog.parent().busy( ( lock ) ? 'show' : 'hide' );
        }
      },

      onChangeShippingFulfillmentList: function ( object ){
        if ( this.CurrentShippingFulfillmentItem != null ){
          this.CurrentShippingFulfillmentItem.hide();
        }
        this.CurrentShippingFulfillmentItem = ep( '#'+'ShippingFulfillmentInfo_' + object.value );
        this.CurrentShippingFulfillmentItem.removeClass('HideElement').show();
        this.showShippingTypeList( object.value );
      },

      submitShippingFulfillment: function (){
      },

      onLoadShippingFulfillment: function (){
        var element = ep( '#'+'PreviousShippingFulfillmentTypeID' );
        var previousId = element.val();
        if ( previousId == '' ){
          element.val(0);
        }
        ep( '#'+'NewShippingFulfillmentTypeID option[value=' + element.val() + ']').attr('selected', true);
        this.onChangeShippingFulfillmentList( element[0] );
      },

      onChangeShippingTypeList: function ( object ){
        if ( this.CurrentShippingTypeItem != null ){
          this.CurrentShippingTypeItem.hide();
        }
        if ( object.value.length ){
          this.CurrentShippingTypeItem = ep( '#'+'ShippingTypeInfo_' + object.value ) ;
          this.CurrentShippingTypeItem.removeClass('HideElement').show();
        }
        else {
          this.CurrentShippingTypeItem = null;
        }
      },

      showShippingTypeList: function ( id_logistic ){
        var pattern = /[0-9]*/ ;
        var listId = '#'+'ShippingType_' + pattern.exec( id_logistic );
        var listObject = jq( listId );
        if ( listObject.length == 0 ){
          listId = '#'+'ShippingType_Rest';
          listObject = jq( listId );
        }
        var currentListId = '#' + this.CurrentShippingTypeList[0].id;
        if ( currentListId != listId ){
          this.CurrentShippingTypeList.hide();
          this.CurrentShippingTypeList = listObject;
          this.CurrentShippingTypeList.removeClass('HideElement').show();
          this.onChangeShippingTypeList( this.CurrentShippingTypeList[0] );
        }
      },

      submitShippingType: function (){
        jq( '#'+'NewShippingTypeID' ).attr( 'value', this.CurrentShippingTypeList[0].value );
      },

      onLoadShippingType: function (){
        this.CurrentShippingTypeList = jq( '#'+'ShippingType_0' );
        var previousId = jq( '#'+'PreviousShippingTypeID' ).val();
        if ( previousId != '' ){
          jq('.ShippingTypeList option[value=' + previousId + ']').attr('selected', true);
        }
      },

      ajaxError: function (){
        ep.alert({
            title: ep('#AddShippingDialogLabels > #AlertErrorTitle').html(),
            content: ep('#AddShippingDialogLabels > #AlertErrorMessage').html(),
            type: 'warn',
            ok: function( event ){}
        });
      },

    };
  }
);