-- #301
CREATE TABLE shopref (
     shoprefid            integer  not null
,    providerid           integer  not null
,    storeid              integer  null
,    shoptypeid           integer  null
,    storeobjectpath      varchar(255)  null
,    storeobjectid        integer  null
,    isprecreated         bool  not null
,    istrialshop          bool  not null
,    isinternaltestshop   bool  not null
,    trialtoliveon        datetime  null
,    closedon             datetime  null
,    deletedon            datetime  null
,    markedfordelon       datetime  null

,   constraint fk_shopref                       primary key (shoprefid)
,   constraint fk_shopref_providerid            foreign key (providerid)
        references provider                         (providerid)
,   constraint fk_shopref_storeid               foreign key (storeid)
        references store                            (storeid)
,   constraint fk_shopref_shoprefid             foreign key (shoprefid)
        references object                           (objectid)
,   constraint fk_shopref_shoptypeid            foreign key (shoptypeid)
        references shoptype                         (shoptypeid)
)
GO
CREATE INDEX i_shopref_provider ON shopref (providerid)
GO

CREATE INDEX i_shopref_store ON shopref (storeid, shoptypeid)
GO

CREATE INDEX i_shopref_shoptype ON shopref (shoptypeid)
GO
